import pdal
caseandcontrols = {
    '0.50' : 'case',
    0.50 : 'control',
    '0.55' : 'case',
    0.55 : 'control',
    '0.60' : 'case',
    0.60 : 'control',
    '0.65' : 'case',
    0.65 : 'control',
    '0.70' : 'case',
    0.70 : 'control',
    '0.75' : 'case',
    0.75 : 'control',
}

#keeping track of the normal heights, the IN heights, and the OUT heights
inandout = ['', 'IN', 'OUT']

studies = ['ASD', 'FSuic']

posneg = ['','NEG_']

#iterating through all of the possible meshes
for toggle in posneg:
    for study in studies:
        for prefix in inandout:
            for key, value in caseandcontrols.items():
                if(prefix == ''):
                    setting = 'both'
                elif (prefix == 'IN'):
                    setting = 'in'
                elif (prefix == 'OUT'):
                    setting = 'out'

                json = """[
                    {
                        "type":"readers.text",
                        "filename":"/Users/josephaguilar/MetabolicLandscapes_python/ASD_and_FSuic/"""+study+"""txt/"""+toggle+prefix+"""coords"""+str(key)+value+""".txt",
                        "header":"x y z",
                        "skip":1
                    },
                    {
                        "type": "filters.delaunay"
                    },
                    {
                        "type":"filters.normal",
                        "viewpoint":"POINT (-833 -833 -833)"
                    },
                    {
                        "type": "writers.ply",
                        "filename": " """+toggle+study+str(key)+setting+value+""".ply",
                        "faces": true
                    }
                ]"""

                pipeline = pdal.Pipeline(json)
                pipeline.execute()