import json
import os

#keeping track of all of the different R values, and whether we're creating a case mesh or a control mesh. 
#one is a float and one is a string, so that you can have both a case and a control with the same R value
posneg = ['', 'NEG_']
caseandcontrols = {
    '0.50' : 'case',
    0.50 : 'control',
    '0.55' : 'case',
    0.55 : 'control',
    '0.60' : 'case',
    0.60 : 'control',
    '0.65' : 'case',
    0.65 : 'control',
    '0.70' : 'case',
    0.70 : 'control',
    '0.75' : 'case',
    0.75 : 'control',
}

#keeping track of the normal heights, the IN heights, and the OUT heights
inandout = ['', 'IN', 'OUT']

pseudopoints = []
cornerpoints = {-3071: 'width', 386: 'length', 889: 'width', 2884: 'length'}

for toggle in posneg:
    for key, value in cornerpoints.items():
        if value == 'width':
            for i in range(386, 2886, 125):
                pseudopoints.append({'x': i, 'y': key, 'z': 0})
        if value == 'length':
            for i in range(-3071, 889, 99):
                pseudopoints.append({'x': key, 'y': i, 'z': 0})

    #loop through each possibility
    for prefix in inandout:
        for key, value in caseandcontrols.items():
            #opening the metabolites data
            f = open('metabolites_for_unity.json')

            #making sure the heights are consistent
            if(isinstance(key,str)):
                e = open(prefix+'heights_'+key+'.json')
            elif not(str(key).endswith('5')):
                e = open(prefix+'heights_'+str(key)+'0.json')
            elif (str(key) == ('0.5')):
                e = open(prefix+'heights_'+str(key)+'0.json') 
            elif (str(key).endswith('5')):
                e = open(prefix+'heights_'+str(key)+'.json') 

            #loading the data from the heights and the metabolites
            pt = json.load(f)
            tall = json.load(e)

            #creating lists that store that data
            mets = pt['metabolites']
            heights = tall['heights']

            #keeping track of the number of loops
            i = 0

            #creating a list of the points and heights
            pts = []
            zs = []

            #exporting each set of coordinates to the right place
            completeName = os.path.join('/Users/josephaguilar/MetabolicLandscapes_python/ASD_and_FSuic/ASDtxt', toggle+prefix+"coords"+str(key)+value+".txt")

            #creating the .xyz file
            myfile = open(completeName,"w")
            myfile.write("x y z \n")



            #going through each metabolite and storing the coordinate and heights
            for met in mets:
                x = mets[i]['x']
                y = mets[i]['z']
                n = 0

                #making sure the heights go to the correct set of coordinates
                for height in heights:
                    if((toggle + mets[i]['ID']) == heights[n]['ID']):
                        z = (heights[n][value+'_height'])*833
                        break
                    else:
                        z = 0.0
                    n+=1
                pts.append({'x': mets[i]['x'],'y': mets[i]['z'],'z' : z})

                #writing the coordinates into the .xyz file
                x, y, z = map(float, (x, y, z))
                myfile.write("%s %s %s \n" %(x,y,z))
                i+=1
            track = 0
            for pseudo in pseudopoints:
                x = pseudopoints[track]['x']
                y = pseudopoints[track]['y']
                z = 0.0
                x, y, z = map(float, (x,y,z))
                myfile.write("%s %s %s \n" %(x,y,z))
                track += 1
            pts.extend(pseudopoints)
            myfile.close()

    print(pts)